  <sly data-sly-use.helper="/libs/granite/sightly/templates/clientlib.html" 
data-sly-call="${helper.all @ categories='training.flexigird'}"/>

<h2>${currentNode.path}</h2>
<h3>${currentNode.path}</h3>

<script type="text/javascript">

/* Grab the JCR path to the content entry that calls this component
 * with Sling, you cannot call a script, you must call the jcr content
 * node that resolves to the representation (script).
 */

 var queryAppernder = '?';
 var archiveParam =  'archive=true';
 var assignParam =  'operation=assign';
 var closeParam =  'operation=close';
 var deleteParam =  'operation=delete';
 var jsonExtn = '.json';
 //var baseURL = '${currentNode.getPath @ context='scriptString'}'; // if using a resourceType based servlet
  var baseURL = "/tekno/toys"; // if using a path based servlet



$(function () {
    $('.lead-table').flexigrid({
        url: baseURL , // This will trigger a request back to AEM
        method:'get',
        dataType: 'json', // The expected response will be JSON formatted data
        colModel : [{
            display : ' Name', name : 'toyName', width : 220, sortable : true, align : 'left', hide: false
        },{
            display : ' Description', name : 'toyDesc', width : 200, sortable : true, align : 'left', hide: false
        },{
            display : ' Price', name : 'toyPrice', width : 200, sortable : true, align : 'left', hide: false
        }],
        buttons : [
            {name: 'Assign', bclass: 'add', onpress : assignLead}, 
            {name: 'Close', bclass: 'edit', onpress : closeLead},
            {name: 'Delete', bclass: 'delete', onpress : deleteLead},
            {separator: true}
            ],
       searchitems : [
            {display: 'Lead Name', name : 'name',isdefault: true},
            {display: 'Email', name : 'leadEmail'},
            {display: 'Status', name : 'status'}
            ],
        sortname: "id",
        sortorder: "asc",
        usepager: true,
        title: "All Leads Grid",
        useRp: true,
        rp: 15,
        showTableToggleBtn: false,
        singleSelect: false,
        width: 700,
        height: 200
    });
});

var handleError=function(error){
   	$("#message").html(error);
   }





function assignLead() {
   	console.log("assigning");
 	var arr = getSelectedValues();
 	console.log(arr);
   	var handleSuccessAssign = function (result){
        		$("#message").html(result);  
    }
    
   	sendRequestToServer(handleSuccessAssign,handleError,assignParam,{user:$('#datalist').find(":selected").val(),emails:arr.toString()});

}

function closeLead() {
   var handleSuccessClose = function (result){
        		$("#message").html(result);  
    }
   sendRequestToServer(handleSuccessClose,handleError,closeParam,{test:$('#datalist').find(":selected").text()});
	
}

 getSelectedValues = function() {
    var arr_val = [];
    var sel = $(".flexigrid .trSelected");
    if (sel.length > 0) {
        for(var i=0; i < sel.length ; i++){
        		var rowData = [];
        		var row = $(sel[i]).find('td');
        		for(var j=0; j < row.length ; j++){
            		rowData.push($(row[j]).find('div').text());
            	}
            arr_val.push(rowData);
        }
    }
  return arr_val;
}






function deleteLead(a,b,c,d,e) {
    var arr = getSelectedValues();
    // alert("heloo");    
    var innerArr = arr[0];
    var toyName = innerArr[0];
    var toyDesc = innerArr[1]; 
    var toyPrice = innerArr[2];
    
    $.ajax({
        type: "PO ST",
        dataType: "json",
        url: baseURL,
        data: jQuery.param({ 'toy-name': toyName, 'toy-desc' : toyDesc, 'toy-price':toyPrice}),
        success: function (result) {
            $("#message").remove(result);
        },
        error:function(error){
            console.error("Error: ",error);
        }
    });

}

    function sendRequestToServer(successHandler,errorHandler,param,requestData){
	     $.ajax({url: baseURL+jsonExtn + queryAppernder + param, 
	     	type:"POST",
	        cache:false,
	        data:requestData, 
	     	success:successHandler,
	     	error:errorHandler
	    });
  }

  /*for (var i = 0; i < temp1.children.length; i++) {
      var element = temp1.children[i];
      console.log(element.abbr);
      console.log(element.innerText.trim());
  }*/

</script>

<div id="message"></div>
<table class="lead-table"></table>
<style>
.wrapper {
    overflow: hidden;
}

.left, .right {
    float:left;
    padding: 10px;
}

#message {
  position: fixed;
  top: 0;
  left: 0;
  z-index: 999;
  width: 100%;
  height: 23px;
  background-color: lightblue;
}
</style>

<div class="wrapper"> 

	<form action="/tekno/generateDoc" class="left" method="post">
		<input type="hidden" name="type" value="pdf"/>
		<input type="submit" value="Generate PDF">
	</form>
	
	<form action="/tekno/generateDoc" class="right" method="post">
		<input type="hidden" name="type" value="csv"/>
		<input type="submit" value="Generate CSV">
	</form>
</div>
